(define-module (elmord utils documentation)
  #:use-module (oop goops)
  #:use-module (elmord utils objects)
  )

;; This is not a proper module yet, just some experiments in ways to
;; extract documentation. Might be nice to generate HTML or Markdown
;; from it.

(define (find-docs mod)
  (module-for-each
   (lambda (name var)
     (let* ([value (variable-ref var)]
            [documentation (extract-documentation value)])
       (when documentation
         (display documentation)
         (newline)
         (newline))))
   mod))


(define (extract-documentation val)
  (or (and (procedure? val) (procedure-documentation val))
      (object-property val 'documentation)))


(find-docs (resolve-module '(elmord utils iterators) #:ensure #f))

(find-docs (resolve-module '(elmord utils sequences) #:ensure #f))
